﻿using Syncfusion.SfDiagram.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Chart
{
    //Employee Business Object    
    public class Employee
    {
        public string ParentId { get; set; }
        public string Name { get; set; }
        public string Designation { get; set; }
        public string EmpId { get; set; }
    }
    //Employee Collection
    public class Employees : ObservableCollection<Employee>
    {
    }

    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            //Initializes the employee collection
            ObservableCollection<Employee> employees = new ObservableCollection<Employee>();
            employees.Add(new Employee() { Name = "Elizabeth", EmpId = "1", ParentId = "", Designation = "CEO" });
            employees.Add(new Employee() { Name = "Christina", EmpId = "2", ParentId = "1", Designation = "Manager" });
            employees.Add(new Employee() { Name = "Yang", EmpId = "3", ParentId = "1", Designation = "Manager" });
            employees.Add(new Employee() { Name = "Yoshi", EmpId = "4", ParentId = "2", Designation = "Team Lead" });
            employees.Add(new Employee() { Name = "Philip", EmpId = "5", ParentId = "2", Designation = "S/w Developer" });
            employees.Add(new Employee() { Name = "Roland", EmpId = "6", ParentId = "3", Designation = "TeamLead" });
            employees.Add(new Employee() { Name = "Yvonne", EmpId = "7", ParentId = "3", Designation = "Testing Engineer" });

            //Initializes the DataSourceSettings
            diagram.DataSourceSettings = new DataSourceSettings() { DataSource = employees, Id = "EmpId", ParentId = "ParentId" };
            diagram.BindingContext = employees;

            //Initializes the Layout
            DirectedTreeLayout treeLayout = new DirectedTreeLayout() { HorizontalSpacing = 80, VerticalSpacing = 50, TreeOrientation = TreeOrientation.TopToBottom };
            diagram.LayoutManager = new LayoutManager() { Layout = treeLayout };

            diagram.BeginNodeRender += (object sender, BeginNodeRenderEventArgs args) =>
            {
                args.Item.Name = "Teste evento";
                AddTemplate(args.Item);
            };
        }

        /// <summary>
        /// To Add data template for Node while rendering
        /// </summary>
        /// <param name="node">Node for which template to be added</param>
        void AddTemplate(Node node)
        {
            node.Width = 100;
            node.Height = 70;
            var template = new DataTemplate(() =>
            {
                StackLayout parent = new StackLayout();
                parent.VerticalOptions = LayoutOptions.FillAndExpand;
                parent.HorizontalOptions = LayoutOptions.FillAndExpand;
                Label label = new Label();
                label.Text = "Teste";
                parent.Children.Add(label);
                return parent;
            });
            node.Template = template;
        }
    }
}
